#include-once

#include <ListBoxConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>

#include "_AudioEndpointVolume.au3"
#include "Utilities.au3"

Func _AddProfileGUI(ByRef $aProfiles, $hParentGUI)
	GUISetState(@SW_DISABLE, $hParentGUI)
	Local $hAddProfileGUI = GUICreate("Add Profile", 210, 226, -1, -1, -1, -1, $hParentGUI)

	GUICtrlCreateLabel("Existing Profiles:", 8, 8, 80, 17)
	Local $hProfileList = GUICtrlCreateList("", 8, 24, 161, 110, BitOR($LBS_NOTIFY, $WS_VSCROLL, $WS_BORDER))
	GUICtrlSetData(-1, _ArrayToString($aProfiles))

	Local $hMoveUp = GUICtrlCreateButton("<", 176, 24, 25, 51)
	GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
	GUICtrlSetState(-1, 128)

	Local $hMoveDown = GUICtrlCreateButton(">", 176, 83, 25, 51)
	GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
	GUICtrlSetState(-1, 128)

	GUICtrlCreateLabel("Name of the new profile:", 8, 144, 119, 17)
	Local $hProfile = GUICtrlCreateInput("", 8, 160, 193, 21)

	Local $hAddNewProfile = GUICtrlCreateButton("Add Profile", 8, 192, 91, 25)
	Local $hDiscardProfile = GUICtrlCreateButton("Discard", 112, 192, 91, 25)
	GUISetState(@SW_SHOW, $hAddProfileGUI)

	While Sleep(10)
		Switch GUIGetMsg()
			Case -3, $hDiscardProfile
				GUIDelete($hAddProfileGUI)
				GUISetState(@SW_ENABLE, $hParentGUI)
				GUISetState(@SW_RESTORE, $hParentGUI)
				Return ""

			Case $hMoveUp
				Local $iIndex = 0

				For $iIndex = 0 To UBound($aProfiles) - 1
					If $aProfiles[$iIndex] = GUICtrlRead($hProfileList) Then ExitLoop
				Next

				Local $sTmp = $aProfiles[$iIndex]

				$aProfiles[$iIndex] = $aProfiles[$iIndex - 1]
				$aProfiles[$iIndex - 1] = $sTmp

				GUICtrlSetData($hProfileList, "")
				GUICtrlSetData($hProfileList, _ArrayToString($aProfiles))

				GUICtrlSetState($hMoveUp, 128)
				GUICtrlSetState($hMoveDown, 128)

				IniExchangeSections("settings.ini", $aProfiles[$iIndex], $aProfiles[$iIndex - 1])

			Case $hMoveDown
				Local $iIndex = 0

				For $iIndex = 0 To UBound($aProfiles) - 1
					If $aProfiles[$iIndex] = GUICtrlRead($hProfileList) Then ExitLoop
				Next

				Local $sTmp = $aProfiles[$iIndex]

				$aProfiles[$iIndex] = $aProfiles[$iIndex + 1]
				$aProfiles[$iIndex + 1] = $sTmp

				GUICtrlSetState($hMoveUp, 128)
				GUICtrlSetState($hMoveDown, 128)

				GUICtrlSetData($hProfileList, "")
				GUICtrlSetData($hProfileList, _ArrayToString($aProfiles))

				IniExchangeSections("settings.ini", $aProfiles[$iIndex], $aProfiles[$iIndex + 1])

			Case $hProfileList
				Local $sSelectedProfile = GUICtrlRead($hProfileList)

				If StringLen($sSelectedProfile) Then
					GUICtrlSetState($hMoveUp, 64)
					GUICtrlSetState($hMoveDown, 64)

					If $sSelectedProfile = $aProfiles[0] Then GUICtrlSetState($hMoveUp, 128)
					If $sSelectedProfile = $aProfiles[UBound($aProfiles) - 1] Then GUICtrlSetState($hMoveDown, 128)
				EndIf

			Case $hAddNewProfile
				Local $sProfile = GUICtrlRead($hProfile)

				;Wenn der Profilname = "Settings" ist oder bereits existiert dann muss ein neuer gewählt werden.
				If StringInStr("Settings|" & _ArrayToString($aProfiles), $sProfile) or Not StringLen($sProfile) Then
					MsgBox(48, "Invalid Profile Name", "Your specified profile name is invalid." & @CRLF & "Please pick a new one.")
				Else
					GUIDelete($hAddProfileGUI)
					GUISetState(@SW_ENABLE, $hParentGUI)
					GUISetState(@SW_RESTORE, $hParentGUI)
					Return $sProfile
				EndIf
		EndSwitch
	WEnd
EndFunc

Func _AddKeyGUI($aKey, $hParentGUI)
	GUISetState(@SW_DISABLE, $hParentGUI)

	Local $bInitialized = False
	Local $hAddKeyGUI = GUICreate("Add Key", 396, 201, -1, -1, -1, -1, $hParentGUI)

	GUICtrlCreateGroup("", 8, 2, 233, 90)

	GUICtrlCreateLabel("Device ID:", 16, 18, 55, 17)
	Local $hDeviceID = GUICtrlCreateInput(IniRead("settings.ini", "Settings", "Device", ""), 80, 15, 153, 21, 1)
	GUICtrlSetState(-1, 128)

	GUICtrlCreateLabel("Key:", 16, 42, 25, 17)
	Local $hKey = GUICtrlCreateInput("", 80, 39, 153, 21, 1)
	GUICtrlSetState(-1, 128)

	GUICtrlCreateLabel("Scan Code:", 16, 66, 60, 17)
	Local $hScanCode = GUICtrlCreateInput("", 80, 63, 153, 21, 1)
	GUICtrlSetState(-1, 128)

	GUICtrlCreateGroup("", 249, 2, 137, 90)

	Local $hOnPress = GUICtrlCreateRadio("OnPress", 265, 26, 113, 17)
	GUICtrlSetState(-1, 1)

	Local $hOnRelease = GUICtrlCreateRadio("OnRelease", 265, 42, 113, 17)

	Local $hOnToggle = GUICtrlCreateRadio("OnToggle", 265, 58, 113, 17)
	GUICtrlSetState(-1, 128)

	GUICtrlCreateGroup("", 8, 94, 378, 97)

	GUICtrlCreateLabel("Command:", 16, 110, 54, 17)
	Local $hCommand = GUICtrlCreateCombo("Execute File", 72, 107, 305, 25, 3)
	GUICtrlSetData(-1, "Keystrokes - Send strokes|Radio - Turn On/Off|Radio - Increase Volume (+2)|Radio - Decrease Volume (-2)|Radio - Mute/Unmute|" & _
					   "Extensa - Switch to previous profile|Extensa - Switch to next profile|Volume - Increase (+2)|Volume - Decrease (-2)|Volume - Mute/Unmute")

	Local $hCommandLabel = GUICtrlCreateLabel("Path:", 16, 137, 55, 17)
	Local $hCommandInput = GUICtrlCreateInput("", 72, 134, 305, 21)

	Local $hTest = GUICtrlCreateButton("Test Command", 71, 160, 116, 25)
	Local $hSave = GUICtrlCreateButton("Save Command", 192, 160, 115, 25)
	Local $hDiscard = GUICtrlCreateButton("Discard", 312, 160, 66, 25)

	If Not UBound($aKey) Then ;Wenn auf Add-Key gedrückt wurde
		GUICtrlSetData($hScanCode, $aKey)
		GUICtrlSetData($hKey, $aScanCodes[$aKey])
	ElseIf UBound($aKey) Then ;Wenn auf Edit-Key gedrückt wurde
		WinSetTitle($hAddKeyGUI, "", "Edit Key")
		ControlCommand($hAddKeyGUI, "", $hCommand, "SelectString", $aKey[0])
		GUICtrlSetState($hCommandInput, 64)

		Switch $aKey[0]
			Case "Execute File"
				GUICtrlSetData($hCommandLabel, "Path:")

			Case "Keystrokes - Send strokes"
				GUICtrlSetData($hCommandLabel, "Keystrokes:")

			Case "Radio - Turn On/Off"
				GUICtrlSetData($hCommandLabel, "Stream:")

			Case "Radio - Mute/Unmute", "Extensa - Switch to previous profile", "Extensa - Switch to next profile", _
				 "Volume - Increase (+2)", "Volume - Decrease (-2)", "Volume - Mute/Unmute"
				GUICtrlSetData($hCommandLabel, "")
				GUICtrlSetState($hCommandInput, 128)
		EndSwitch

		GUICtrlSetData($hCommandInput, $aKey[1])
		GUICtrlSetData($hKey, $aScanCodes[$aKey[2]])
		GUICtrlSetData($hScanCode, $aKey[2])

		If $aKey[3] = 0 Then
			GUICtrlSetState($hOnPress, 64 + 4)
			GUICtrlSetState($hOnRelease, 64 + 1)
			GUICtrlSetState($hOnToggle, 128 + 4)
		ElseIf $aKey[3] = 1 Then
			GUICtrlSetState($hOnPress, 64 + 1)
			GUICtrlSetState($hOnRelease, 64 + 4)
			GUICtrlSetState($hOnToggle, 128 + 4)
		ElseIf $aKey[3] = 2 Then
			GUICtrlSetState($hOnPress, 128 + 4)
			GUICtrlSetState($hOnRelease, 128 + 4)
			GUICtrlSetState($hOnToggle, 64 + 1)
		EndIf
	EndIf

	GUISetState(@SW_SHOW, $hAddKeyGUI)

	While Sleep(10)
		Switch GUIGetMsg()
			Case -3, $hDiscard
				GUIDelete($hAddKeyGUI)
				GUISetState(@SW_ENABLE, $hParentGUI)
				GUISetState(@SW_RESTORE, $hParentGUI)
				Return -1

			Case $hTest
				Switch GUICtrlRead($hCommand)
					Case "Execute File"
						ShellExecute(GUICtrlRead($hCommandInput))

					Case "Keystrokes - Send strokes"
						Sleep(2000)
						Send(GUICtrlRead($hCommandInput))

					Case "Radio - Turn On/Off"
						_StreamRadioTest(GUICtrlRead($hCommandInput))

					Case "Extensa - Switch to previous profile"
						;Switch to previous profile

					Case "Extensa - Switch to next profile"
						;Switch to next profile

					Case "Volume - Increase (+2)"
						_SetMasterVolumeLevelScalar(_GetMasterVolumeLevelScalar() + 2)

					Case "Volume - Decrease (-2)"
						_SetMasterVolumeLevelScalar(_GetMasterVolumeLevelScalar() - 2)

					Case "Volume - Mute/Unmute"
						_SetMute(_GetMute() ? 0 : 1)
				EndSwitch

			Case $hSave
				GUICtrlSetData($hCommandInput, StringReplace(GUICtrlRead($hCommandInput), "|", ""))

				Local $aReturn[4] = [GUICtrlRead($hCommand), GUICtrlRead($hCommandInput), GUICtrlRead($hScanCode), BitAND(GUICtrlRead($hOnPress), 1) + BitAND(GUICtrlRead($hOnToggle), 1) * 2]

				GUIDelete($hAddKeyGUI)
				GUISetState(@SW_ENABLE, $hParentGUI)
				GUISetState(@SW_RESTORE, $hParentGUI)
				Return $aReturn

			Case $hCommand
				GUICtrlSetState($hCommandInput, 64)
				GUICtrlSetData($hCommandInput, "")

				GUICtrlSetState($hOnPress, 65)
				GUICtrlSetState($hOnRelease, 64)
				GUICtrlSetState($hOnToggle, 128)

				If UBound($aKey) and Not $bInitialized Then
					$bInitialized = True
					GUICtrlSetData($hCommandInput, $aKey[1])
				EndIf

				Switch GUICtrlRead($hCommand)
					Case "Execute File"
						GUICtrlSetData($hCommandLabel, "Path:")

					Case "Keystrokes - Send strokes"
						GUICtrlSetData($hCommandLabel, "Keystrokes:")

					Case "Extensa - Switch to previous profile", "Extensa - Switch to next profile"
						GUICtrlSetData($hCommandLabel, "")
						GUICtrlSetState($hCommandInput, 128)
						GUICtrlSetState($hOnPress, 128)
						GUICtrlSetState($hOnRelease, 65)
						GUICtrlSetState($hOnToggle, 128)

					Case "Radio - Turn On/Off"
						GUICtrlSetData($hCommandLabel, "Stream:")
						GUICtrlSetState($hOnPress, 128)
						GUICtrlSetState($hOnRelease, 128)
						GUICtrlSetState($hOnToggle, 65)

					Case "Radio - Increase Volume (+2)", "Radio - Decrease Volume (-2)", "Volume - Increase (+2)", "Volume - Decrease (-2)"
						GUICtrlSetData($hCommandLabel, "")
						GUICtrlSetState($hCommandInput, 128)

					Case "Radio - Mute/Unmute", "Volume - Mute/Unmute"
						GUICtrlSetData($hCommandLabel, "")
						GUICtrlSetState($hCommandInput, 128)
						GUICtrlSetState($hOnPress, 128)
						GUICtrlSetState($hOnRelease, 128)
						GUICtrlSetState($hOnToggle, 65)
				EndSwitch
		EndSwitch
	WEnd
EndFunc