#include-once

Global Const $aScanCodes[] = ["", "ESC", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "", "", "BACKSPACE", "TAB", "Q", "W", "E", "R", "T", "Z", "U", "I", "O", "P", "", "+", "ENTER", "CTRL", "A", "S", "D", "F", "G", _
							  "H", "J", "K", "L", "", "", "^", "LSHIFT", "#", "Y", "X", "C", "V", "B", "N", "M", ",", ".", "-", "RSHIFT", "NUMPAD*", "LALT", "", "CAPSLOCK", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", _
							  "NUMLOCK", "SCROLLLOCK", "NUMPAD7", "NUMPAD8", "NUMPAD9", "NUMPAD-", "NUMPAD4", "NUMPAD5", "NUMPAD6", "NUMPAD+", "NUMPAD1", "NUMPAD2", "NUMPAD3", "NUMPAD0", "NUMPAD,", "", "", "", "F11", "F12"]

Global $hDLL

Opt("TrayMenuMode", 1)
Opt("TrayOnEventMode", 1)
TrayCreateItem("Exit")
TrayItemSetOnEvent(-1, "_Exit")

Func _Exit()
	DllClose($hDLL)
	Exit
EndFunc

Func _KillWorker()
	Do
		ProcessClose("extensaw.exe")
	Until Not ProcessExists("extensaw.exe")
EndFunc

Func _GetKey($hDLL, $iBlockDevice = -1)
	$aResult = DllCall($hDLL, "dword:cdecl", "getKey", "int", $iBlockDevice)

	$iDeviceNr = Int($aResult[0] / 10000)
	$iScanCode = Mod($aResult[0], 1000)
	$iState = Not (Number(StringRight($aResult[0], 4)) >= 1000)

	;Ternre-Abfrage $iDeviceNr < 50 ist wichtig da wenn nichts gedrckt wird
	;als Device etwas zwischen 0 bis 50~ zurckkommt. Da kein HWID-String Hash so kurz ist sollte kein Gert ignoriert werden. //Update 06-2017: Nicht mehr feststellbar.
	Local $aReturn[3] = [$iDeviceNr, $iScanCode, $iState]
	Return $aReturn
EndFunc

Func _StreamRadio(ByRef $oWMP, $sStreamingLink, $bPlay = True)
	If $bPlay Then
		$oWMP.URL = $sStreamingLink
		$oWMP.settings.Volume = 100
		$oWMP.controls.Play()
	Else
		$oWMP.controls.Stop()
		$oWMP = 0
	EndIf
EndFunc

Func _StreamRadioTest($sStreamingLink)
	$oWMP = ObjCreate("WMPlayer.ocx")
	$oWMP.URL = $sStreamingLink
	$oWMP.settings.Volume = 100
	$oWMP.Controls.Play()

	For $i = 0 To 500
		Sleep(10)
		ToolTip(_GetPlayState($oWMP.playState()))
	Next

	$oWMP.Controls.Stop()
	$oWMP = 0
	ToolTip("")
EndFunc

Func _GetPlayState($iState)
	Local $aStates[12] = ["Undefined", "Stopped", "Paused", "Playing", "ScanForward", "ScanReverse", "Buffering", "Waiting", "MediaEnded", "Transitioning", "Ready", "Reconnecting"]
	Return $aScanCodes[$iState]
EndFunc

Func _AbbreviateCommand($sCommand)
	Switch $sCommand
		Case "Execute File"
			Return $sCommand

		Case "Keystrokes - Send strokes"
			Return "Send Keys"

		Case "Radio - Turn On/Off"
			Return "Radio - On/Off"

		Case "Radio - Increase Volume (+2)"
			Return "Radio - Vol Up"

		Case "Radio - Decrease Volume (-2)"
			Return "Radio - Vol Down"

		Case "Radio - Mute/Unmute"
			Return "Radio - (Un)Mute"

		Case "Extensa - Switch to previous profile"
			Return "Extensa - Previous Profile"

		Case "Extensa - Switch to next profile"
			Return "Extensa - Next Profile"

		Case "Volume - Increase (+2)"
			Return "Volume Up"

		Case "Volume - Decrease (-2)"
			Return "Volume Down"

		Case "Volume - Mute/Unmute"
			Return "Volume - (Un)Mute"
	EndSwitch
EndFunc

Func IniExchangeSections($sIniFile, $sFirstSection, $sSecondSection)
	Local $aSectionNames = IniReadSectionNames($sIniFile)
	Local $aSectionData[$aSectionNames[0]][0][2]

	For $i = 1 To $aSectionNames[0]
		Local $aCurrentSection = IniReadSection($sIniFile, $aSectionNames[$i])

		If UBound($aCurrentSection) > UBound($aSectionData, 2) Then ReDim $aSectionData[$aSectionNames[0]][UBound($aCurrentSection)][2]

		For $j = 0 To UBound($aCurrentSection) - 1
			$aSectionData[$i - 1][$j][0] = $aCurrentSection[$j][0]
			$aSectionData[$i - 1][$j][1] = $aCurrentSection[$j][1]
		Next
	Next

	Local $iFirstIndex, $iSecondIndex

	For $i = 1 To $aSectionNames[0]
		If $aSectionNames[$i] = $sFirstSection Then $iFirstIndex = $i - 1
		If $aSectionNames[$i] = $sSecondSection Then $iSecondIndex = $i - 1
	Next

	$aSectionNames[$iFirstIndex + 1] = $sSecondSection
	$aSectionNames[$iSecondIndex + 1] = $sFirstSection

	Local $aFirstTmp[UBound($aSectionData, 2)][2]

	For $i = 0 To UBound($aSectionData, 2) - 1
		$aFirstTmp[$i][0] = $aSectionData[$iFirstIndex][$i][0]
		$aFirstTmp[$i][1] = $aSectionData[$iFirstIndex][$i][1]
	Next

	For $i = 0 To UBound($aSectionData, 2) - 1
		$aSectionData[$iFirstIndex][$i][0] = $aSectionData[$iSecondIndex][$i][0]
		$aSectionData[$iFirstIndex][$i][1] = $aSectionData[$iSecondIndex][$i][1]

		$aSectionData[$iSecondIndex][$i][0] = $aFirstTmp[$i][0]
		$aSectionData[$iSecondIndex][$i][1] = $aFirstTmp[$i][1]
	Next

	FileDelete($sIniFile)

	For $i = 1 To $aSectionNames[0]
		Local $aTmp[0][2]

		For $j = 0 To UBound($aSectionData, 2) - 1
			If Not StringLen($aSectionData[$i - 1][$j][0]) Then ExitLoop

			ReDim $aTmp[UBound($aTmp) + 1][2]
			$aTmp[UBound($aTmp) - 1][0] = $aSectionData[$i - 1][$j][0]
			$aTmp[UBound($aTmp) - 1][1] = $aSectionData[$i - 1][$j][1]
		Next

		IniWriteSection($sIniFile, $aSectionNames[$i], $aTmp)
	Next
EndFunc